#ifndef J_MALLOC_H
#define J_MALLOC_H

/* a malloc wrapper for debugging and tracing memory pressure */

#include <stdlib.h>
#include <assert.h>

static inline void* jmalloc(size_t size)
{
  void* address = malloc(size);
  assert(address != NULL);
  
  return address;
}

static inline void jfree(void* address)
{
  assert(address != NULL);
  free(address);
}


#endif
