#ifndef J_DNS_H
#define J_DNS_H

#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>


static inline int dns_get_ip(const char *host, struct sockaddr_in *peer)
{
  struct hostent *h = gethostbyname(host);  
  char **h_addr;
  struct in_addr *in;
  if( h == NULL )
    return 0;
 
  h_addr = h->h_addr_list; 
  in = (struct in_addr*)(*h_addr); 
  
  peer->sin_port = htons(80);
  peer->sin_family = PF_INET;
  peer->sin_addr = *in; 
  
  return 1;
}





#endif
